<?php

namespace Teknisa\CADFIS\Controllers; 

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO;
use Geral\Util\DateUtil;
use Teknisa\CADFIS\Services\Dfs87000AutorizacaoObterXmlService;

class Dfs87000AutorizacaoObterXmlController{ 
    
    protected $service;
    protected $crudService;
    protected $parameterBag;
    
    public function __construct($crudService, $parameterBag, Dfs87000AutorizacaoObterXmlService $service){
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->service = $service;
    }

    public function replicaAutorizacao(DTO\Request\Row $request, DTO\Response $response){
        try{
            
            $row  = $request->getRow();
            
            $dataSet = $this->service->replicaAutorizacao($row);
    
            if(!empty($dataSet)) {
                $this->crudService->save("autoobterxmlie", $dataSet);
            }
            
            
        } catch(\Exception $e){
            $response->setError(new DTO\Response\Error($e->getMessage(), 500));
        }
    }
   
    
}