<?php
namespace Teknisa\CADFIS\Factories;

use Teknisa\Libs\Util\Environment;
use Teknisa\CADFIS\Factories;
use Teknisa\CADFIS\Strategies;
use Teknisa\CADFIS\Strategies\MarcaStrategy;
use Teknisa\CADFIS\Strategies\MarcProdStrategy;
use Teknisa\CADFIS\Strategies\ProdFornStrategy;
use Teknisa\CADFIS\Strategies\CompradorStrategy;
use Teknisa\CADFIS\Strategies\ProdCompStrategy;
use Teknisa\CADFIS\Strategies\RegiaoStrategy;
use Teknisa\CADFIS\Strategies\GerenteStrategy;
use Teknisa\CADFIS\Strategies\FormPgtoStrategy;
use Teknisa\CADFIS\Strategies\FornecedorStrategy;

class StrategiesFactory 
{
    public function __construct(Environment $environment, Factories\ServicesFactory $servicesFactory)
    {
        $this->environment = $environment;
        $this->servicesFactory = $servicesFactory;
    }
    
    public function getFactory($tableName)
	{
	    switch ($tableName) {
            case 'MARCA':
                $factory = new MarcaStrategy($this->servicesFactory->getMarcaService(), $this->environment);
                break;
            case 'MARCPROD':
                $factory = new MarcProdStrategy($this->servicesFactory->getMarcProdService(), $this->environment);
                break;
            case 'PRODFORN':
                $factory = new ProdFornStrategy($this->servicesFactory->getProdFornService(), $this->environment);
                break;
            case 'COMPRADOR':
                $factory = new CompradorStrategy($this->servicesFactory->getCompradorService(), $this->environment);
                break;
            case 'PRODCOMP':
                $factory = new ProdCompStrategy($this->servicesFactory->getProdCompService(), $this->environment);
                break;
            case 'REGIAO':
                $factory = new RegiaoStrategy($this->servicesFactory->getRegiaoService(), $this->environment);
                break;
            case 'GERENTE':
                $factory = new GerenteStrategy($this->servicesFactory->getGerenteService(), $this->environment);
                break;
            case 'FORMPGTO':
                $factory = new FormPgtoStrategy($this->servicesFactory->getFormPgtoService(), $this->environment);
                break;
            case 'FORNECEDOR':
                $factory = new FornecedorStrategy($this->servicesFactory->getFornecedorService(), $this->environment);
                break;
            
            default:
                throw new Exception("Não existe estratégia para a tabela informada!", 400);
                break;
        }
        
	    return $factory;
	}
}