<?php
namespace Teknisa\CADFIS\Services;

use Doctrine\DBAL\Connection;
use Teknisa\Libs\Util\Environment;
use Teknisa\CADFIS\Services\GeneralService as GeneralService;

class FormPgtoService
{
    protected $dataSourceName = "formpgto";
    protected $entityManager;
    protected $crudService;
    protected $generalService;
    
    public function __construct($entityManager, $crudService, Connection $connection, Environment $environment)
    {
        $this->entityManager = $entityManager;
        $this->crudService = $crudService;
        $this->connection = $connection;
        $this->environment = $environment;
        $this->generalService = new GeneralService($this->connection, $this->environment);
    }
    
    public function verifyFormPgtoExists($row)
    {
        $query = "SELECT CDFORMPGTO
                    FROM FORMPGTO
                   WHERE CDFORMPGTO = :P_CDFORMPGTO
                     AND NRORG = :P_NRORG";
        $params = array(
            'P_CDFORMPGTO'  => $row['CDFORMPGTO'],
            'P_NRORG'       => $this->environment->getNrorg(),
        );

        $stmt = $this->connection->prepare($query);
        $stmt->execute($params);
        
        return $stmt->fetch();
    }
    
    public function saveImport($rows)
    {
        $this->crudService->save($this->dataSourceName, $rows);
    }
}    